<pre>
<?php
	
	// globalni vektor vah vstupu jednotlivych neuronu	 
	$w = array();
			 
	// nahodne nastaveni pocatecnich vah
	function random_reset()
	{
		global $w;
		
		for ( $i = 1; $i <= 3; $i++ )
		{
			for ( $j = 1; $j <= 3; $j++ )
			{
				$w[$i][$j] = (float)(rand(0, 65535) / (65535/2) - 1);
			}		
		}
	}
	
	// aktivacni funkce
	function sigmoida($val)
	{
		return 1 / (1 + exp(-(float)$val));	
	} 
	
	// odezva neuronove site
	function run($inp1, $inp2)
	{
		global $w;
		
		$net1 = 1 * $w[1][1] + $inp1 * $w[2][1] + $inp2 * $w[3][1];
		$net2 = 1 * $w[1][2] + $inp1 * $w[2][2] + $inp2 * $w[3][2];
		
		$i3 = sigmoida($net1);
		$i4 = sigmoida($net2);
		
		$net1 = 1 * $w[1][3] + $i3 * $w[2][3] + $i4 * $w[3][3];
		
		return sigmoida($net1);
	} 
	
	// uceni neuronove site
	function train($inp1, $inp2, $out)
	{
		global $w;
		
		// vstup skryte vrstvy
		$net1 = 1 * $w[1][1] + $inp1 * $w[2][1] + $inp2 * $w[3][1];
		$net2 = 1 * $w[1][2] + $inp1 * $w[2][2] + $inp2 * $w[3][2];
		
		// vystup skryte vrstvy, respektive: vstup treti vrstvy
		$i3 = sigmoida($net1);
		$i4 = sigmoida($net2);
		
		// vystup treti vrstvy
		$net1 = 1 * $w[1][3] + $i3 * $w[2][3] + $i4 * $w[3][3];
		$fout = sigmoida($net1);
	
		$d = array();
		$d[3] = $fout * ( 1 - $fout ) * ($out - $fout);
		$d[2] = $i4 * ( 1 - $i4 ) * $w[3][3] * $d[3];
		$d[1] = $i3 * ( 1 - $i3 ) * $w[2][3] * $d[3];
		
		// learning-rate
		$lr = 0.6;
		
		for ( $i = 1; $i <= 3; $i++ ) // cykl pres vsechny vrstvy
		{
			if ( $i == 3 )
			{
				$v1 = $i3;
				$v2 = $i4;
			}
			else
			{
				$v1 = $inp1;
				$v2 = $inp2;			
			}
			
			// zmena vah
			$w[1][$i] += $lr * 1 * $d[$i];
			$w[2][$i] += $lr * $v1 * $d[$i];
			$w[3][$i] += $lr * $v2 * $d[$i];
		}
	}
	
	random_reset();
	

	// pozadovany vystup (XOR)
	$A = 0.0;
	$B = 1.0;
	$C = 1.0;
	$D = 0.0;
	
	// cyklus uceni
	for ( $i = 0; $i < 10000; $i++ )
	{
		train(0.0, 0.0, $A);
		train(0.0, 1.0, $B);
		train(1.0, 0.0, $C);
		train(1.0, 1.0, $D);

		// realne vystupy		
		$a = run(0.0, 0.0);
		$b = run(0.0, 1.0);
		$c = run(1.0, 0.0);
		$d = run(1.0, 1.0);		
		
		// vypocet chyby
		$chyba = 0.5 * (($A-$a)*($A-$a) + ($B-$b)*($B-$b) + ($C-$c)*($C-$c) + ($D-$d)*($D-$d));
		
		if ( $chyba <= 0.01 )
			break;
	}
	
	// vysledek	
	echo "pocet cyklu k nauceni: {$i}, chyba: {$chyba}\n";
	echo sprintf("XOR: [%s %s %s %s]\n", round($a, 3), round($b, 3), round($c, 3), round($d, 3));	